// Copyright (C) 2012 - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

//
// Compute the Euler totient function
// euler(36)=12
n = 36;
phi = number_eulertotient(n);
assert_checkequal(phi,12);
// euler(32)=16
n = 32;
phi = number_eulertotient(n);
assert_checkequal(phi,16);
// See http://oeis.org/A000010
table = [1, 1, 2, 2, 4, 2, 6, 4, 6, 4, 10, 4, 12, 6, 8, 8, 16, 6, 18, 8, 12, 10, 22, 8, 20, 12, 18, 12, 28, 8, 30, 16, 20, 16, 24, 12, 36, 18, 24, 16, 40, 12, 42, 20, 24, 22, 46, 16, 42, 20, 32, 24, 52, 18, 40, 24, 36, 28, 58, 16, 60, 30, 36, 32, 48, 20, 66, 32, 44];
for n = 1 : 69
  phi = number_eulertotient(n);
  assert_checkequal(phi,table(n));
end
