// Copyright (C) 2008-2009 - INRIA - Michael Baudin
//
// This file must be used under the terms of the CeCILL.
// This source file is licensed as described in the file COPYING, which
// you should have received as part of this distribution.  The terms
// are also available at
// http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt

// <-- JVM NOT MANDATORY -->

// See the multiplicative group modulo 10
Z = number_multgroupmod(10);
expected = [1 3 7 9]';
assert_checkequal(Z,expected);

// See the multiplicative group modulo 14
expected = [1.    3.    5.    9.    11.    13.]';
Z = number_multgroupmod(14);
assert_checkequal(Z,expected);

// Check the size of all multiplicative groups 
// modulo m, for m=1,2,...,20
for m = 1 : 20
  Z = number_multgroupmod(m);
  euphi = number_eulertotient(m);
  assert_checkequal(size(Z),[euphi 1]);  
end
